

#ifndef _IBRC_CLIENT_H
#define _IBRC_CLIENT_H

/*
 * Programmgeruest fuer die Aufgabe IBRC, Teil 2
 * Erstellt fuer das PKS im SS05
 * Zefir, kurtisi@ibr.cs.tu-bs.de
 *-----------------------------------------------
 */


/*
 * Konstanten
 */

/* Audio wird mit 16 kHz abgetastet / ausgegeben */
#define SAMPLE_RATE		(16000)

/* max. beruecksichtigte Laenge der Eingabezeile */
#define MSG_MAX_LEN		511

/* Timer wird alle 20 ms getriggert */
#define TIMER_TICK_MS	20 


/*
 * Funktionen fuer den Zugriff auf Audio
 *
 * Bemerkung: PortAudio wird aus den GUI-Routinen geoeffnet und geschlossen
 */

int read_audio(char *buff, int size);	// aus PortAudio-In-Buffer lesen
int write_audio(char *buff, int size);	// in PortAudio-Out-Buffer schreiben

/*
 * Funktionen der grafischen Oberflaeche
 */

void bye();							// Client beenden
void setName(char *name);			// Hostname setzen
void setNick(char *nick);			// Nickname setzen
void setChannel(char *channel);		// Kanalnamen setzen

void printSystemMessage(char *msg);				// Systemnachricht ausgeben
void printOwnMessage(char *msg);				// Eigene Nachricht ausgeben
void printMessage(char *from, char *msg);		// Usernachricht ausgeben
void printPrivMessage(char *from, char *msg);	// Private Nachricht ausgeben



/*
 * Zu implementierende Funktionen
 */

void init(char *server, int port);	// Initialisierung des Systems
void quit();						// Beenden des Systems
void userInput(char *input);		// Eingabe bearbeiten
void mainloop();					// Periodischer Aufruf


#endif /*_IBRC_CLIENT_H*/